// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'dart:io';

import 'package:wyatt_cli_toolbox/src/prompt/list_chooser.dart';
import 'package:wyatt_cli_toolbox/src/prompt/question.dart';
import 'package:wyatt_cli_toolbox/src/stylish/stylish.dart';

class ListQuestion extends Question<String> {
  ListQuestion(
    String question,
    this.options, {
    String? comment,
    required String identifier,
  }) : super(QuestionType.listQuestion, identifier, question, comment);

  List<String> options;
  String? answer;

  @override
  String formatComment() => (super.formatComment().trim().isEmpty)
      ? ' (User arrow keys) '.dim()
      : super.formatComment();

  @override
  String ask() {
    stdout.writeln(formatQuestion());
    final ListChooser chooser = ListChooser(options);
    final String input = chooser.choose();
    answer = input;
    return input;
  }
}
