// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:http/http.dart';
import 'package:wyatt_http_client/src/authentication/interfaces/url_authentication_client.dart';
import 'package:wyatt_http_client/src/utils/convert.dart';
import 'package:wyatt_http_client/src/utils/utils.dart';

class UnsafeAuthenticationClient extends UrlAuthenticationClient {
  final String username;
  final String password;

  final String usernameField;
  final String passwordField;

  UnsafeAuthenticationClient({
    required this.username,
    required this.password,
    this.usernameField = 'username',
    this.passwordField = 'password',
    BaseClient? inner,
  }) : super(inner);

  @override
  BaseRequest modifyRequest(BaseRequest request) {
    final url =
        request.url + '?$usernameField=$username&$passwordField=$password';
    return Utils.copyRequestWith(request, url: url);
  }
}
